/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * Device criteria.
 */
@ApiModel(description = "Device criteria.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Device {
  @SerializedName("brand")
  private String brand = null;

  @SerializedName("model")
  private String model = null;

  @SerializedName("age")
  private BigDecimal age = null;

  @SerializedName("power")
  private BigDecimal power = null;

  @SerializedName("price")
  private BigDecimal price = null;

  @SerializedName("quantity")
  private BigDecimal quantity = null;

  @SerializedName("energy_source")
  private String energySource = null;

  public Device brand(String brand) {
    this.brand = brand;
    return this;
  }

   /**
   * Brand of the device.
   * @return brand
  **/
  @ApiModelProperty(example = "VERGNE", value = "Brand of the device.")
  public String getBrand() {
    return brand;
  }

  public void setBrand(String brand) {
    this.brand = brand;
  }

  public Device model(String model) {
    this.model = model;
    return this;
  }

   /**
   *  Model of the device.
   * @return model
  **/
  @ApiModelProperty(example = "Edens", value = " Model of the device.")
  public String getModel() {
    return model;
  }

  public void setModel(String model) {
    this.model = model;
  }

  public Device age(BigDecimal age) {
    this.age = age;
    return this;
  }

   /**
   * Age of the device (in year).
   * @return age
  **/
  @ApiModelProperty(example = "5.0", value = "Age of the device (in year).")
  public BigDecimal getAge() {
    return age;
  }

  public void setAge(BigDecimal age) {
    this.age = age;
  }

  public Device power(BigDecimal power) {
    this.power = power;
    return this;
  }

   /**
   * Power of the device, in kWh.
   * @return power
  **/
  @ApiModelProperty(example = "120.0", value = "Power of the device, in kWh.")
  public BigDecimal getPower() {
    return power;
  }

  public void setPower(BigDecimal power) {
    this.power = power;
  }

  public Device price(BigDecimal price) {
    this.price = price;
    return this;
  }

   /**
   * Price of the device.
   * @return price
  **/
  @ApiModelProperty(example = "1234.56", value = "Price of the device.")
  public BigDecimal getPrice() {
    return price;
  }

  public void setPrice(BigDecimal price) {
    this.price = price;
  }

  public Device quantity(BigDecimal quantity) {
    this.quantity = quantity;
    return this;
  }

   /**
   * Number of devices that the customer wants to cover.
   * @return quantity
  **/
  @ApiModelProperty(example = "3.0", value = "Number of devices that the customer wants to cover.")
  public BigDecimal getQuantity() {
    return quantity;
  }

  public void setQuantity(BigDecimal quantity) {
    this.quantity = quantity;
  }

  public Device energySource(String energySource) {
    this.energySource = energySource;
    return this;
  }

   /**
   * Device energy source.
   * @return energySource
  **/
  @ApiModelProperty(example = "gaz", value = "Device energy source.")
  public String getEnergySource() {
    return energySource;
  }

  public void setEnergySource(String energySource) {
    this.energySource = energySource;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Device device = (Device) o;
    return Objects.equals(this.brand, device.brand) &&
        Objects.equals(this.model, device.model) &&
        Objects.equals(this.age, device.age) &&
        Objects.equals(this.power, device.power) &&
        Objects.equals(this.price, device.price) &&
        Objects.equals(this.quantity, device.quantity) &&
        Objects.equals(this.energySource, device.energySource);
  }

  @Override
  public int hashCode() {
    return Objects.hash(brand, model, age, power, price, quantity, energySource);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Device {\n");
    
    sb.append("    brand: ").append(toIndentedString(brand)).append("\n");
    sb.append("    model: ").append(toIndentedString(model)).append("\n");
    sb.append("    age: ").append(toIndentedString(age)).append("\n");
    sb.append("    power: ").append(toIndentedString(power)).append("\n");
    sb.append("    price: ").append(toIndentedString(price)).append("\n");
    sb.append("    quantity: ").append(toIndentedString(quantity)).append("\n");
    sb.append("    energySource: ").append(toIndentedString(energySource)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

